﻿Imports System.Reflection

Public Class AddInManager

    Public Shared Sub LoadAddIn(path As String, ParamArray args As Object())
        Dim AddIn As [Assembly] = [Assembly].LoadFrom(path)

        Dim t As Type = AddIn.GetType(AddIn.GetName.Name & ".Main")

        InvokeMethod(t, "OnCreateAddIn", Nothing)

        InvokeMethod(t, "OnCreateMainForm", {args(0)})

        InvokeMethod(t, "OnCreateMenuStrip", {args(1)})

        InvokeMethod(t, "OnCreateToolStrip", {args(2)})
    End Sub

    Private Shared Sub InvokeMethod(t As Type, name As String, args() As Object)
        Dim mtd As MethodInfo = t.GetMethod(name)
        Dim classInstance As Object = Activator.CreateInstance(t, True)
        mtd.Invoke(classInstance, args)
    End Sub
End Class
